/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
    3 D S 2 P L G . C     by    Hkan "ZAP" Andersson
                                Email: zap@lysator.liu.se
                                   
    V 1.0  920422   Initial build
    V 1.1  920427   Default file support added
                                         
                    (c) 1992 Hkan "Zap" Andersson
                                   
    This program accept as input "ascii" files generated by 3D Studio
    1.0, and probably 2.0 as well (not tested yet).
       
    It borrows heavily from the 3D Studio loading code in RayTracker,
    a commercial ray tracing program for AutoCAD and 3D Studio models.
    More info about RayTracker is available from the Author. Animations
    created with RayTracker is available with anonymous FTP from
    phoenix.oulu.fi, talk to hole@phoenix.oulu.fi!
       
    Please note, that if you do "SAVE ASCII" in the keyframer of
    3D Studio, you save all objects in their native coordinate system,
    suitable for building into a "figure" file. If you save in the
    3D Editor, you get them in the position they actually have.

    You may use this code, and extend upon it as needed. However, keep
    this header in your adaption, and add to it information about the
    changes you have made.

    You should normally not need to change anything. I will probably
    add some kind of "collaps all those damned triangles in the same
    plane to more complex polygons" optimization one rainy day.
       
    At first i though: "Real programmers don't comment their code - if it
    was hard to write it should be hard to read!". But since it wasn't hard
    to write, I found myself forced to comment it. Not a lot, but probably
    enough for you out there....
       
                                            / Zap

- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

#include <stdio.h>
#include <string.h>

void load_3ds();

float scale; /* The scale factor FLOAT -> INTEGER scaling */

#define TRUE 1
#define FALSE 0

#define MAX_MATERIALS 100
#define MAX_NAME_LENGTH 40

int already_read = 0;

char attribute[1000], object_name[80];  /* Some crap areas */

/* The list of colors for the DEMO2.C implementation of REND386 */

shocol()
{
   printf("\n\n  1 = Red");
   printf("\n  2 = Orange");
   printf("\n  3 = Pink");
   printf("\n  4 = Beige");
   printf("\n  5 = Lt Yellow");
   printf("\n  6 = Yellow");
   printf("\n  7 = Lt green");
   printf("\n  8 = Green");
   printf("\n  9 = Turqoise");
   printf("\n 10 = Lt Blue");
   printf("\n 11 = Blue");
   printf("\n 12 = Lt Purple");
   printf("\n 13 = Purple");
   printf("\n 14 = Dk gray");
   printf("\n 15 = Lt Gray\n");
}

/* Some stuff to put the materials in... */

char materials[MAX_MATERIALS][MAX_NAME_LENGTH];
int materialsn[MAX_MATERIALS];
char last_material[MAX_NAME_LENGTH] = "Oy Oy Oy";
int nlast_material = 0;

/* Changes all underscores to spaces.... or was it the other way around?? */

char un_space(str)
char *str;
{
   while (*str)
   {
      if (*str == ' ') *str = '_';
      str++;
   }
}

int n_materials = 0;

/* Function returns the color number for the material string in p */
/* and asks if not defined previously */

int add_texture(p)
char *p;
{
   int i, zook, wook;
   
   /* For speed... */
   
   if (stricmp(last_material,p) == 0)
      return nlast_material;
   
   for (i = 0; i < n_materials; i++)
   {
      if (stricmp(materials[i],p) == 0)
      {
         strcpy(last_material, p);
         nlast_material = materialsn[i];
         
         return nlast_material;
      }
   }
   
   strcpy(materials[n_materials],p);
   strcpy(last_material, p);
   
   zook = 0;
   printf("\nMaterial %s Fixed/Cosine/Metal/Glass: ",p);
      
   switch (getch())
   {
      case 'f':
      case 'F': 
         zook = 0x0000;
         printf("\nFixed color index ->");
         scanf("%d",&wook);
         zook |= wook;
            
         break;
      case 'm':
      case 'M': 
         zook = 0x2000;
         shocol();
         printf("\nMetal base color: (1 - 15) ->");
         scanf("%d",&wook);            
         zook |= ((wook << 8) & 0x0f00);
         printf("\nColor cycle offset (0 - 255) ->");
         scanf("%d",&wook);            
         zook |= (0x00ff);
         break;                        
            
      case 'g':
      case 'G': 
         zook = 0x3000;
         shocol();
         printf("\nGlass base color: (1 - 15) ->");
         scanf("%d",&wook);            
         zook |= ((wook << 8) & 0x0f00);
         printf("\nColor cycle offset (0 - 255) ->");
         scanf("%d",&wook);            
         zook |= (0x00ff);
         break;                        
         
      default:
         zook = 0x1000;
         shocol();
         printf("\nCosine base color: (1 - 15) ->");
         scanf("%d",&wook);            
         zook |= ((wook << 8) & 0x0f00);
         printf("\nBase color brightness (0 - 255) ->");
         scanf("%d",&wook);            
         zook |= (0x00ff);
         break;                        
   }
      
   materialsn[n_materials] = zook;
   
   nlast_material = zook;
   
   printf("\nResulting cidx = %d (%d)\n",zook,nlast_material);
   
   n_materials++;
   
   if (n_materials >= MAX_MATERIALS)
   {
      printf("KerWham!\a Oh no!\ Repent!\a The end is near!\a");
      printf("You have tried to make more than %d materials!", MAX_MATERIALS);
      exit(0);
   }
   
   return zook;
}

/* Load a defaultfile 

   The format of the file is the simplest possible: 
   Each line defines a material. The material name has all spaces 
   replaced with underscores, and is followed by the color value
   to use for it. Heavy, eh? 

*/

void load_defaultfile()
{
   FILE *fp;
   
   fp = fopen("material.def","r");
   
   if (!fp)
   {
      printf("\nNo material database exist - new created!");      
      return;
   }
   
   while (fscanf(fp,"%s %d",materials[n_materials],&materialsn[n_materials])
           == 2)
   {  
      n_materials++;
      
      if (n_materials >= MAX_MATERIALS)
      {
         printf("KerWham!\a Oh no!\a Please!\a Spare me this!\a Oh Oh!\a");
         printf("MATERIALS.DEF has more than %d materials!", MAX_MATERIALS);
         exit(0);
      }  
   }  
   fclose(fp);
}

/* Save a defaultfile */

void save_defaultfile()
{
   int i;
   FILE *fp;
   
   fp = fopen("material.def","w");
   
   if (!fp)
   {
      printf("KerWham! Could not save material database!!??!!\n");
      exit(0);
   }

   /* If I had the strength I would probably test for diskfull in the
      below for loop, but I wouldn't wanna make my fingers shorter than
      they already are, and by the way I have wasted enough time while
      writing this pointless comment so it would have been even easier
      if I had written the bloody "if (fprintf.... != 2) go_boom()" 
      in the first place, but now it is too late, I wont do it!!! */
   
   for (i = 0; i < n_materials; i++)
   {
      fprintf(fp,"%s %d\n",materials[i],materialsn[i]);
   }
   
   fclose(fp);
}


/* Command line parameters:

   Mandatory: <fname>  -  Filename to process, assumed to end in .ASC
   Optional:  <scale>  -  Scale factor
      
*/
      
main(argc,argv)
int argc;
char **argv;
{
   char innamn[80],utnamn[80];
   char *p;

   scale = 10.0; /* Pretty arbitrary */

   if (argc < 2)
   {
      printf("\n3DS2PLG v 1.1 by ZAP\n");
      printf("\nUsage: 3DS2PLG <fname> [<scale>]\n");
      printf("\n  Where <fname> is the name of the 3D Studio ASCII file without .ASC");
      printf("\n  and <scale> is the scalefactor used when transforming floating");
      printf("\n  point coordinates to integers. Default = 10.0\n");
      printf("\n3DS2PLG is written and (c) 1992 Hkan 'Zap' Andersson, zap@lysator.liu.se");
      printf("\nhave fun using it and spreading it to other REND386 users!\n");
      exit(0);
   }
   
   if (argc == 3)
      sscanf(argv[2],"%g",&scale);
   
   p = strrchr(argv[1],'.');
   
   if (p) *p = 0;
   
   strcpy(innamn,argv[1]);
   strcpy(utnamn,argv[1]);
   
   strcat(innamn,".asc");
   strcat(utnamn,".plg");
   
   load_3ds(innamn,utnamn);   /* Go 4 it, babe! */
}

/* Dummy function for the RayTracker "context" dialog box (just to show
   the user the progress.... */

void context(str)
char *str;
{
   printf("\nProcesssing: %s...",str);
}

/* Compare two strings up to the length of the second string */

int stris(a,b)
char *a,*b;
{
   return (strnicmp(a,b,strlen(b))==0);
}

/* This function parses a 3D Studio "ASCII" file as generated with the
   menu option "Save ASCII". This code is an adaption of the 3D Studio
   ASCII file loading code in RayTracker.
      
   It warns for tokens it does not recognize, like "Background" and
   similar. This has no impact on the conversion and is just information. */

void load_3ds(innamn,utnamn)
char *innamn,*utnamn;
{
   FILE *in, *ut;
   struct {float x,y,z;} p1;
   char *p;
   int vcount, fcount;

   load_defaultfile();
   
   in = fopen(innamn,"r");
   ut = fopen(utnamn,"w");
   
   if (!in || !ut)
   {
      printf("Could not open file(s)");
      exit(-1);
   }
   
   while (!feof(in))
   {
      if (!already_read)
      {  
         do 
         {
            fgets(attribute,1000,in);
            attribute[strlen(attribute)-1] = 0;
         } while ((attribute[0] <= 32) && ! feof(in));
      }
      already_read = FALSE;
      
      /* Empty row: End of things... */
      if (attribute[0] == 0)
      {
      }
      else
      if (stris(attribute,"Ambient light"))
      {
/*       
         ambient_intensity = 1;
      
         p = strstr(attribute,"Red=") + 4;
         sscanf(p,"%g",&ambient_light.r);
         p = strstr(attribute,"Green=") + 6;
         sscanf(p,"%g",&ambient_light.g);
         p = strstr(attribute,"Blue=") + 5;
         sscanf(p,"%g",&ambient_light.b);
*/       
      }
      else
      if (stris(attribute,"Named object:"))
      {
         strtok(attribute,":");
         p = strtok(NULL,":");
         strcpy(object_name,p+1);
      
         context(object_name);
         
         un_space(object_name);
      } 
      else
      if (stris(attribute,"Tri-mesh"))
      { 
         strtok(attribute,":");
         p = strtok(NULL,":");
         sscanf(p,"%d",&vcount);
         
         p = strtok(NULL,":");
         sscanf(p,"%d",&fcount);
         
         fprintf(ut, "%s %d %d\n", object_name, vcount, fcount);
      }
      else
      if (stris(attribute,"Vertex list"))
      {
         context("Vertex list...");
      }
      else
      if (stris(attribute,"Vertex"))
      { 
         long px,py,pz;
         
         p = strstr(attribute,"X:") + 3;
         sscanf(p,"%g",&p1.x);
         p = strstr(attribute,"Y:") + 3;
         sscanf(p,"%g",&p1.y);
         p = strstr(attribute,"Z:") + 3;
         sscanf(p,"%g",&p1.z);

         px = p1.x * scale;
         pz = p1.y * scale;
         py = p1.z * scale;         
         
         fprintf(ut,"%ld %ld %ld\n",px,py,pz);
      }
      else
      if (stris(attribute,"Face list:"))
      { 
         context("Face list");
      } 
      else
      if (stris(attribute,"Face "))
      {
         int t,v1,v2,v3;
         
         p = strstr(attribute,"A:") + 2;
         sscanf(p,"%d",&v1);
         p = strstr(attribute,"B:") + 2;
         sscanf(p,"%d",&v2);
         p = strstr(attribute,"C:") + 2;
         sscanf(p,"%d",&v3);
         
         p = strstr(attribute,"Mtl:") + 4;
         un_space(p);
         t = add_texture(p);
         
         fprintf(ut,"%d 3 %d %d %d\n",t,v1,v2,v3);
         
         do 
         {
            fgets(attribute,1000,in);
            attribute[strlen(attribute)-1] = 0;
         } while ((attribute[0] <= 32) && ! feof(in));
         
         /* Is it a flat face? */
         if (!stris(attribute,"Smooth"))
         {
            already_read = TRUE;
         }  
      }
      else
      if (stris(attribute,"Camera ("))
      {
      }
      else
      if (stris(attribute,"Position:"))
      {

      }
      else
      if (stris(attribute,"Target:"))
      {
      }
      else
      if (stris(attribute,"Direct light"))
      {
      }
      else
      if (stris(attribute,"Light color:"))
      {  
      } 
      else
      if (stris(attribute,"Spotlight to:"))
      {
      }
      else
      if (stris(attribute,"Falloff size:"))
      {
      }
      else
      if (stris(attribute,"Bank angle:"))
      { 
      }
      else
      {
         strtok(attribute," ");
                        
         printf("Unrecognized token in 3DS File\n'%s'\n(might be wrong file type)\a",attribute);
      }
   }

   /* If it was an object... end it nicely... */

   save_defaultfile();
   
   fclose(ut);
   fclose(in);
}
